var FrozenTissueDate = function()
{
	var ftd = {};
	var debug = 0;
	

	ftd.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', ftd.validateStep1);
		Wizard.initFileSelectionField('importfile');
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goimport', Wizard.goRegister);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', ftd.submit);

		Doc.show('step-1');
		Doc.show('goimport');
	}
	
	ftd.validateStep1 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('importfile');
		if (!valid) event.preventDefault();
	}

	ftd.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var url = '../Import.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportFrozenTissueDate';
		url += '&file='+encodeURIComponent(frm.importfile.value);
		url += '&progressbar=import-frozen-tissue-progress';
		
		Wizard.showLoadingAnimation('Importing FrozenTissueDate...', 'import-frozen-tissue-progress');
		Wizard.asyncJsonRequest(url, ftd.submissionResults, 'POST');
	}
	
	ftd.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		if (response.warnings && response.warnings.length)
		{
			var html = '';
			for (var warningNo = 0; warningNo < response.warnings.length; warningNo++)
			{
				var warning = response.warnings[warningNo];
				html += '<tr class="highlight">';
				html += '<td>'+warning.line+'</td>';
				html += '<td>'+Strings.encodeTags(warning.reason)+'</td>';
				html += '<td>'+Strings.encodeTags(warning.provId);
				if (warning.caseName)
				{
					html += '<img class="link case-summary" data-name="'+Strings.encodeTags(warning.caseName)+'" src="../images/case_summary.png">';
				}
				html += '</td>';
				html += '<td>'+Strings.encodeTags(warning.comment)+'</td>';
				html += '</tr>';
			}
			Doc.element('import-warnings').innerHTML = html;
			
			var cs = document.getElementsByClassName('case-summary');
			for (var i = 0; i < cs.length; i++)
			{
				Events.addEventHandler(cs[i], 'click', ftd.showCaseSummary);
			}

			Doc.show('warnings-section');
		}
		Doc.show('gorestart');
	}

	ftd.showCaseSummary = function(event)
	{
		var name = Data.get(event.currentTarget, 'name');
		var caseName = name.substring(0, 7);
		var url = '../reports/case_summary.jsp?ID='+App.getSessionId();
		url += '&caseName='+encodeURIComponent(caseName);
		url += '&pageType=popup';
		Dialogs.openPopup(url, 'CaseSummary'+caseName, 1000, 700);
	}

	return ftd;
}();

Doc.onLoad(FrozenTissueDate.initPage);

